Rhino C++ API
8.13
|
Macros | |
#define | POLYGON_MAX_NUMSIDES 50000 |
#define | POLYGON_MIN_NUMSIDES 3 |
Typedefs | |
typedef struct tagRH_LINE | RH_LINE |
used by CRhinoGet::Line2d() to return 2d screen line. More... | |
#define POLYGON_MAX_NUMSIDES 50000 |
#define POLYGON_MIN_NUMSIDES 3 |
Copyright (c) 1993-2017 Robert McNeel & Associates. All rights reserved. Rhinoceros is a registered trademark of Robert McNeel & Associates.
THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY. ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
For complete Rhino SDK copyright information see http://www.rhino3d.com/developer.
typedef struct tagRH_LINE RH_LINE |
used by CRhinoGet::Line2d() to return 2d screen line.
CRhinoCommand::result GetAnnotationLeader | ( | const CRhinoDoc & | doc, |
CArgsRhinoAnnotationLeader & | dimargs, | ||
CRhinoAnnotationLeader *& | output_leader, | ||
CRhinoHistory * | history | ||
) |
Interactive leader drawing
CRhinoCommand::result GetSubCurveRange | ( | CArgsRhinoGetSubCurve & | args, |
ON_Interval & | range, | ||
bool | bAdjustOrder = true |
||
) |
[in,out] | args | [in/out] |
[out] | range | [out] - parameter range on args.curve |
bAdjustOrder | allow ordering of parameters to put smaller one first if this is false, return picks in the order they are made |
RHINO_SDK_FUNCTION bool RhinoCalculateCircleTanTan | ( | const ON_Curve * | c1, |
const ON_Curve * | c2, | ||
double | seed1, | ||
double | seed2, | ||
ON_Circle & | result | ||
) |
Description: Calculates a circle that is tangent to 2 curves. Parameters: c1 [in] - The first curve. c2 [in] - The second curve. seed1 [in] - A seed parameter on the first curve. seed2 [in] - A seed parameter on the second curve. result [out] - The results of the calculation. Return: true or false indicating success or failure.
RHINO_SDK_FUNCTION bool RhinoCalculateCircleTanTanTan | ( | const ON_Curve * | c1, |
const ON_Curve * | c2, | ||
const ON_Curve * | c3, | ||
double | seed1, | ||
double | seed2, | ||
double | seed3, | ||
ON_Circle & | result | ||
) |
Description: Calculates a circle that is tangent to 3 curves. Parameters: c1 [in] - The first curve. c2 [in] - The second curve. c3 [in] - The third curve. seed1 [in] - A seed parameter on the first curve. seed2 [in] - A seed parameter on the second curve. seed3 [in] - A seed parameter on the third curve. result [out] - The results of the calculation. Return: true or false indicating success or failure.
RHINO_SDK_FUNCTION int RhinoChooseOneObject | ( | CRhinoView * | view, |
POINT | view_point, | ||
int | objref_count, | ||
const CRhinoObjRef * | objref_array, | ||
int * | selected_object_index, | ||
int | default_object_index = -1 , |
||
ON_SimpleArray< CRhinoObject * > * | visibility_hint = 0 , |
||
bool | bShowAllOption = false |
||
) |
Description: Visual user interface tool to choose one object from a list. Parameters: view - [in] view where ambiguous pick occurred view_point - [in] window coordinates where ambiguous pick occurred. objref_count - [in] number of object references in objref_array[] objref_array - [in] selected_object_index - [out] index of selected object default_object_index - [in] if >= 0 and < objref_count, then this object is the default. visibility_hint - [in] By default, in a shaded view point pick, RhinoChooseOneObject() will ask the user show only visible candidates. If objects are were visible when the pick occurred but are no longer visible, then pass them in here. For example, if a wire frame object was selected when the pick occurred but was deselected before the call to RhinoChooseOneObject(), then pass its point in this array. bShowAllOption - [in] When true, "All" option is added to the list and when selected the return code is 4.
Returns: @untitle table 0 none selected 1 one selected 2 user canceled 3 one object selected - selection was automatically reduced to one by culling 4 "All" option selected
RHINO_SDK_FUNCTION bool RhinoCreateSpiral | ( | CArgsRhinoGetSpiral & | args, |
ON_NurbsCurve & | curve_out | ||
) |
Description: Calculates a spiral or helical curve based on set of input arguments. Note, RhinoGetHelix and RhinoCreateSpiral call this function to perform the actual curve calculation. Parameters: args - [in] The creation arguments. curve_out - [out] The resulting spiral or helical curve. Returns: True is successful, false otherwise. See Also: RhinoGetHelix RhinoGetSpiral
RHINO_SDK_FUNCTION bool RhinoCreateSpiral | ( | const ON_Curve & | rail, |
double | rail_t0, | ||
double | rail_t1, | ||
ON_3dPoint | radius_point, | ||
double | pitch, | ||
double | turn_count, | ||
double | radius0, | ||
double | radius1, | ||
int | points_per_turn, | ||
ON_NurbsCurve & | curve_out | ||
) |
Description: Low-level function to calculate the C2 non-rational uniform cubic NURBS approximation of a swept helix or spiral Parameters: rail - [in] The rail curve. rail_t0 - [in] Starting portion of rail curve's domain to sweep along. rail_t1 - [in] Ending portion of rail curve's domain to sweep along. radius_point - [in] Point used only to get a vector that is perpedicular to rail'(rail_t0). So (start_point-rail(rail_t0) must not be parallel to rail'(rail_t0). pitch - [in] The pitch (see Remarks). turn_count - [in] The turn count (see Remarks). radius0 - [in] Starting radius (see Remarks).
radius1 - [in] Ending radius (see Remarks). points_per_turn - [in] Number of points to interpolate per turn. Value must be >= 4. 12 seems to work well. curve_out - [out] The output NURBS curve Returns: True if successful, false otherwise. Remarks: If turn_count != 0, then the resulting helix will have this many turns. If turn_count == 0, then pitch must be != 0 and the approximate distance between turn will be set to pitch. Use positive turn_count/pitch for right handed helices and negative turn_count/pitch for left handed helices. At least radii one must be nonzero. Negative values are allowed.
RHINO_SDK_FUNCTION bool RhinoCreateSpiral | ( | ON_3dPoint | axis_start, |
ON_3dVector | axis_dir, | ||
ON_3dPoint | radius_point, | ||
double | pitch, | ||
double | turn_count, | ||
double | radius0, | ||
double | radius1, | ||
ON_NurbsCurve & | curve_out | ||
) |
Description: Low-level function to calculate the C1 cubic NURBS approximation of a helix or spiral. Parameters: axis_start - [in] Helix's axis starting point or center of spiral. axis_dir - [in] Helix's axis vector or normal to spiral's plane. radius_point - [in] Point used only to get a vector that is perpedicular to the axis. In particular, this vector must not be (anti)parallel to the axis vector. pitch - [in] = 0 : Spiral > 0 : Distance between helix's "threads" turn_count - [in] != 0: Number of turns in spiral or helix. > 0 : Right handed or counter-clockwise orientation. < 0 : Left handed or clockwise orientation. Note, for a helix, turn_count * pitch = length of the helix's axis. radius0 - [in] Starting radius.
radius1 - [in] Ending radius. curve_out - [out] The output NURBS curve. Returns: True if successful, false otherwise. Remarks: For a helix, you may have r0 == r1. For a spiral r0 == r1 produces a circle. Zero and negative radii are permissible.
RHINO_SDK_FUNCTION int RhinoCutPlane | ( | const ON_Line & | line_in, |
const ON_Plane & | plane, | ||
const ON_BoundingBox & | bbox, | ||
ON_3dPoint | rect_out[4] | ||
) |
four 3d corners of the output rectangle
Gets a bounded plane that cuts through a boundingbox The output rectangle is perpendicular to the input plane and parallel to the input line
line_in | line included in the output rectangle |
plane | plane perpendicular to the output rectangle |
bbox | bounding box through which to cut |
RHINO_SDK_FUNCTION CRhinoView* RhinoGet2dRectangle | ( | ON_4iRect & | rect, |
int | pen_style = PS_SOLID |
||
) |
Description: Get a rectangle in view window coordinates. Parameters: rect - [out] rectangle 0 <= left < right <= view width 0 <= top < bottom <= view height pen_style - [in] (default = PS_SOLID) style of pen to use for drawing the dynamic 2d rectangle. Returns: Pointer to the view the rectangle is in or NULL if the user canceled. Remarks: The user can either click_down-drag-release or click_down-release-drag-click_down to draw the rectangle. See Also: CRhinoGetPoint::Get2dRectangle
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetArc | ( | CArgsRhinoGetArc & | , |
ON_Arc & | , | ||
CRhinoHistory * | = NULL |
||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetBox | ( | CArgsRhinoGetBox & | args, |
ON_3dPoint | box_corners[8], | ||
CRhinoHistory * | history = NULL |
||
) |
Description: Get a 3d box Parameters: args - [in] controls how the box is picked, prompts, etc. box_corners - [out] corners of the box.
7______________6 |\ |\ | \ | \ | \ _____________\ | 4 | 5 | | | | | | | | 3---|----------2 | \ | \ | \ | \ | \ | \ | \0_____________\1
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCCHTcone | ( | CArgsRhinoGetTube & | args, |
ON_Brep & | Tcone | ||
) |
Description: UI tool to get a tcone. Old style. Circle, circle, height. Parameters: args - [in] controls get point prompts, options, etc. tcone - [out] tcone returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCircle | ( | CArgsRhinoGetCircle & | args, |
ON_Circle & | output_circle | ||
) |
Global Utility function to interactively get a Circle Starts in Center/Radius mode. If an option is chosen for another construction method, switches to that method Used by the circle command
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCircle2Point | ( | CArgsRhinoGetCircle & | args, |
ON_Circle & | output_circle | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCircle3Point | ( | CArgsRhinoGetCircle & | args, |
ON_Circle & | output_circle | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCircleCenterRadius | ( | CArgsRhinoGetCircle & | args, |
ON_Circle & | output_circle | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCircleFitPoints | ( | CArgsRhinoGetCircle & | args, |
ON_Circle & | output_circle | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCircleTTT | ( | CArgsRhinoGetCircle & | args, |
ON_Circle & | output_circle | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCircleTTR( CArgsRhinoGetCircle& args, ON_Circle& output_circle, CRhinoHistory* history = NULL );
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetColor | ( | const wchar_t * | prompt, |
BOOL32 | bAcceptNothing, | ||
BOOL32 | bUseAlpha, | ||
ON_Color & | output_color | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetColor | ( | const wchar_t * | prompt, |
BOOL32 | bAcceptNothing, | ||
ON_Color & | output_color | ||
) |
Description: Easy to use color getter. Parameters: prompt - [in] command prompt bAcceptNothing - [in] if true, the user can press enter output_color - [out] color value returned here Returns: CRhinoCommand::success - got color CRhinoCommand::nothing - user pressed enter CRhinoCommand::cancel - user cancel color getting Remarks: If you need options or more advanced user interface, then use CRhinoGetColor. See Also: CRhinoGetColor CRhinoGet::AddCommandOptionColor
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCone | ( | CArgsRhinoGetCone & | args, |
ON_Cone & | cone | ||
) |
Description: UI tool to get a cone. Parameters: args - [in] controls get point prompts, options, etc. cone - [out] cone returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCone | ( | CArgsRhinoGetConeExtra & | args, |
ON_Cone & | cone | ||
) |
Description: New and improved UI tool to get a cone. Prompts for and maintains height. Parameters: args - [in] controls get point prompts, options, etc. cone - [out] cone returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetControlPointCurve | ( | CArgsRhinoGetCurve & | args, |
ON_NurbsCurve & | curve_out | ||
) |
Description: Interactively get a control point curve. Parameters: args - [in/out] controls prompts and options available when getting the curve. curve_out - [out] curve returned here Returns: CRhinoCommand::success - successfully got curve CRhinoCommand::cancel - user canceled CRhinoCommand::failure - unable to get valid curve Remarks: The Rhino "Curve" command uses RhinoGetControlPointCurve.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCylinder | ( | CArgsRhinoGetCylinder & | args, |
ON_Cylinder & | cylinder | ||
) |
Description: UI tool to get a cylinder. Parameters: args - [in] controls get point prompts, options, etc. cylinder - [out] cylinder returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetCylinder | ( | CArgsRhinoGetCylinderExtra & | args, |
ON_Cylinder & | cylinder | ||
) |
Description: New and improved UI tool to get a cylinder. Prompts for and maintains height and also has a BothSides option. Parameters: args - [in] controls get point prompts, options, etc. cylinder - [out] cylinder returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipse | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
describe RhinoGetEllipse
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipseAroundCurve | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
RhinoGetEllipseAroundCurve.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipseCenter | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
RhinoGetEllipseCenter.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipseCenterCorner | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
RhinoGetEllipseCenterCorner.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipseCorner | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
RhinoGetEllipseCorner.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipseDiameter | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
RhinoGetEllipseDiameter.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipseFromFoci | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
RhinoGetEllipseFromFoci.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetEllipsoid | ( | CArgsRhinoGetEllipse & | , |
ON_Ellipse & | , | ||
ON_Ellipse & | , | ||
CRhinoHistory * | = NULL |
||
) |
describe RhinoGetEllipsoid
RHINO_SDK_FUNCTION bool RhinoGetFileReaderIdFromFileName | ( | const wchar_t * | sFileName, |
ON_UUID & | file_type_id, | ||
int & | file_type_index | ||
) |
Description: Determine if core Rhino or a file import plug-in can write files with the specified extension. Parameters: sFileName - [in] Full file path or file name. file_type_id - [out] nil: Nothing in Rhino can read files with this extension. RhinoApp().RhinoCurrent_UUID(): The file extension is .3dm, .3dmbak or .3dm.bak. Otherwise: Id of a file import plug-in that reads files with the specified extension. file_type_index - [out] -1: Nothing in Rhino can read files with this extension. >=0: File type index for this file.
RHINO_SDK_FUNCTION bool RhinoGetFileReaderIdFromFileNameExtension | ( | const wchar_t * | sFileNameExtension, |
ON_UUID & | file_type_id, | ||
int & | file_type_index | ||
) |
Description: Determine if core Rhino or a file import plug-in can write files with the specified extension. Parameters: sFileNameExtension - [in] FIle extension (leading "." is optional). file_type_id - [out] nil: Nothing in Rhino can read files with this extension. RhinoApp().RhinoCurrent_UUID(): The file extension is .3dm, .3dmbak or .3dm.bak. Otherwise: Id of a file import plug-in that reads files with the specified extension. file_type_index - [out] -1: Nothing in Rhino can read files with this extension. >=0: File type index for this file.
RHINO_SDK_FUNCTION bool RhinoGetFileWriterIdFromFileName | ( | const wchar_t * | sFileName, |
ON_UUID & | file_type_id, | ||
int & | file_type_index | ||
) |
Description: Determine if core Rhino or a file import plug-in can write files with the specified extension. Parameters: sFileName - [in] Full file path or file name. file_type_id - [out] nil: Nothing in Rhino can read files with this extension. RhinoApp().RhinoCurrent_UUID(): The file extension is .3dm, .3dmbak or .3dm.bak. Otherwise: Id of a file import plug-in that reads files with the specified extension. file_type_index - [out] -1: Nothing in Rhino can read files with this extension. >=0: File type index for this file.
RHINO_SDK_FUNCTION bool RhinoGetFileWriterIdFromFileNameExtension | ( | const wchar_t * | sFileNameExtension, |
ON_UUID & | file_type_id, | ||
int & | file_type_index | ||
) |
Description: Determine if core Rhino or a file import plug-in can write files with the specified extension. Parameters: sFileNameExtension - [in] FIle extension (leading "." is optional). file_type_id - [out] nil: Nothing in Rhino can read files with this extension. RhinoApp().RhinoCurrent_UUID(): The file extension is .3dm, .3dmbak or .3dm.bak. Otherwise: Id of a file import plug-in that reads files with the specified extension. file_type_index - [out] -1: Nothing in Rhino can read files with this extension. >=0: File type index for this file.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetHelix | ( | CArgsRhinoGetSpiral & | args, |
ON_NurbsCurve & | curve_out, | ||
CRhinoHistory * | history = NULL |
||
) |
Description: Interactively creates a helical curve. Parameters: args - [in/out] The creation arguments. curve_out - [out] The resulting helical curve. history - [out] Optional history. Returns: CRhinoCommand::success if successful. See Also: RhinoGetSpiral RhinoCreateSpiral
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetInteger | ( | const wchar_t * | prompt, |
BOOL32 | bAcceptNothing, | ||
int & | output_number, | ||
double | lower_limit = ON_UNSET_VALUE , |
||
double | upper_limit = ON_UNSET_VALUE |
||
) |
Description: Easy to use integer getter. Parameters: prompt - [in] command prompt bAcceptNothing - [in] if true, the user can press enter output_integer - [in/out] default integer to this value and integer value returned here lower_limit - [in] Returns: CRhinoCommand::success - got integer CRhinoCommand::nothing - user pressed enter CRhinoCommand::cancel - user cancel integer getting Remarks: If you need options or more advanced user interface, then use CRhinoGetinteger. See Also: CRhinoGetInteger CRhinoGet::AddCommandOptioninteger
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetInterpolatedCurve | ( | CArgsRhinoGetCurve & | args, |
ON_NurbsCurve & | curve_out | ||
) |
Description: Interactively get an interpolated curve. Parameters: args - [in/out] controls prompts and options available when getting the curve. curve_out - [out] curve returned here Returns: CRhinoCommand::success - successfully got curve CRhinoCommand::cancel - user canceled CRhinoCommand::failure - unable to get valid curve Remarks: The Rhino "InterpCrv" command uses RhinoGetInterpolatedCurve.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetInterpolatedCurveOnSurface | ( | const ON_Surface * | pS, |
ON_Curve ** | ppCout, | ||
CRhinoObjRef * | pObjRefOut = 0 , |
||
ON_SimpleArray< ON_2dPoint > * | pPointsOut = 0 |
||
) |
Description: Interactively get an interpolated curve on surface. Parameters: pS - [in] surface on which to draw curve, or NULL to prompt user ppCout - [out] curve returned here pObjRefOut - [out] optionally the picked face is returned here if pS = NULL pPointsOut - [out] optionally the picked 2d points are returned here Returns: CRhinoCommand::success - successfully got curve CRhinoCommand::cancel - user canceled CRhinoCommand::failure - unable to get valid curve Remarks: The Rhino "InterpCrvOnSrf" command uses RhinoGetInterpolatedCurveOnSurface.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetLine | ( | CArgsRhinoGetLine & | , |
ON_Line & | , | ||
CRhinoHistory * | = NULL |
||
) |
Description: Use RhinoGetLine() to interactively get an ON_Line. The Rhino "Line" command uses RhinoGetLine. Use the CArgsRhinoGetLine argument to specify input options like prompts, fixed starting points, and so on. See CArgsRhinoGetLine for complete details. The line is returned as the second argument. If you are getting a line in a command and want to provide history support, then pass a pointer to a CRhinoHistory class as the third argument.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetNumber | ( | const wchar_t * | prompt, |
BOOL32 | bAcceptNothing, | ||
BOOL32 | is_integer, | ||
double & | output_number, | ||
double | lower_limit = ON_UNSET_VALUE , |
||
double | upper_limit = ON_UNSET_VALUE |
||
) |
Description: Easy to use number getter. Parameters: prompt - [in] command prompt bAcceptNothing - [in] if true, the user can press enter is_integer - [in] if true then value constrainded to integer value output_number - [in/out] default number to this value and number value returned here lower_limit - [in] Returns: CRhinoCommand::success - got number CRhinoCommand::nothing - user pressed enter CRhinoCommand::cancel - user cancel number getting Remarks: If you need options or more advanced user interface, then use CRhinoGetNumber. See Also: CRhinoGetInteger CRhinoGet::AddCommandOptionNumber
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetParabola | ( | CArgsRhinoGetParabola & | args, |
ON_BezierCurve & | parabola_out, | ||
CRhinoHistory * | history = NULL |
||
) |
Description: UI tool to get a parabola curve. Parameters: args - [in/out] used to specify ui elements and return user choices, focus, and vertex. parabola_out - [out] parabola returned here history - [out] optional history information returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetParaboloid | ( | CArgsRhinoGetParabola & | args, |
ON_Brep *& | paraboloid_out, | ||
CRhinoHistory * | history = NULL |
||
) |
Description: UI tool to get a paraboloid surface or solid. Parameters: args - [in/out] used to specify ui elements and return user choices, focus, and vertex. paraboloid_out - [out] paraboloid returned here history - [out] optional history information returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetPlane | ( | CArgsRhinoGetPlane & | arg, |
ON_Plane & | plane, | ||
CRhinoHistory * | history = NULL |
||
) |
Gets an oriented infinite plane.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetPoint | ( | const wchar_t * | prompt, |
BOOL32 | bAcceptNothing, | ||
ON_3dPoint & | point | ||
) |
Copyright (c) 1993-2021 Robert McNeel & Associates. All rights reserved. Rhinoceros is a registered trademark of Robert McNeel & Associates.
THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY. ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
For complete Rhino SDK copyright information see http://www.rhino3d.com/developer. Description: Easy to use point getter. Parameters: prompt - [in] command prompt bAcceptNothing - [in] if true, the user can press enter point - [out] point value returned here history_value_id - [in] optional history value id. If history_value_id > 0 and history != NULL, and a snap is used to create the point, then a PointOnObject value is added. history - [in/out] optional history record Returns: CRhinoCommand::success - got point CRhinoCommand::nothing - user pressed enter CRhinoCommand::cancel - user cancel point getting Remarks: If you need options or more advanced user interface, then use CRhinoGetPoint.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetPoint | ( | const wchar_t * | prompt, |
BOOL32 | bAcceptNothing, | ||
ON_3dPoint & | point, | ||
int | history_value_id, | ||
CRhinoHistory * | history | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetPolygon | ( | CArgsRhinoGetPolygon & | args, |
ON_Polyline & | polygon_out, | ||
CRhinoHistory * | history = NULL |
||
) |
interactive Polygon getter declaration
[in,out] | args | [in/out] |
[out] | polygon_out | [out] Polygon returned here |
[out] | history | [out] optional history returned here |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetPolyline | ( | CArgsRhinoGetPolyline & | args, |
ON_Polyline & | output_polyline, | ||
CRhinoHistory * | history = NULL |
||
) |
Description: Interactively get a polyline. Parameters: args - [in/out] controls prompts and options available when getting the polyline. output_polyline - [out] polyline returned here history - [out] optional history record. Returns: CRhinoCommand::success - successfully go polyline CRhinoCommand::cancel - user canceled CRhinoCommand::failure - unable to get valid polyline Remarks: The Rhino "Polyline" command uses RhinoGetPolyline.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetRailRevolveInput | ( | CArgsRhinoRailRevolve & | args | ) |
Description: Interactively get input for RhinoRailRevolve. Parameters: CArgsRhinoRailRevolve& args - [in/out] Returns: CRhinoCommand::success if valid input was specified. See Also: RhinoRailRevolve
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetRectangle | ( | CArgsRhinoGetPlane & | args, |
ON_3dPoint | rectangle_corners[4], | ||
CRhinoHistory * | history = NULL |
||
) |
Description: Get a 3d rectangle. Parameters: args - [in] rectangle_corners - [out] corners of rectangle in counter clockwise order history - [in/out] Returns: CRhinoCommand::success if successful. See Also: RhinoGetScreenRectangle
rectangle_corners | output ordered counter clockwise |
history | optional history recorder |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetRevolve | ( | CArgsRhinoRevolve & | args, |
ON_SimpleArray< ON_RevSurface * > & | srfs_out | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetSphere | ( | CArgsRhinoGetSphere & | args, |
ON_Sphere & | output_sphere | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetSpiral | ( | CArgsRhinoGetSpiral & | args, |
ON_NurbsCurve & | curve_out, | ||
CRhinoHistory * | history = NULL |
||
) |
Description: Interactively creates a spiral curve. Parameters: args - [in/out] The creation arguments. curve_out - [out] The resulting spiral curve. history - [out] Optional history. Returns: CRhinoCommand::success if successful. See Also: RhinoGetHelix RhinoCreateSpiral
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetString | ( | const wchar_t * | prompt, |
BOOL32 | bAcceptNothing, | ||
ON_wString & | output_string | ||
) |
Description: Easy to use string getter. Parameters: prompt - [in] command prompt bAcceptNothing - [in] if true, the user can press enter output_string - [in/out] default string set to this value and string value returned here Returns: CRhinoCommand::success - got string CRhinoCommand::nothing - user pressed enter CRhinoCommand::cancel - user cancel string getting Remarks: If you need options or more advanced user interface, then use CRhinoGetString. See Also: CRhinoGetString CRhinoGet::AddCommandOption
CRhinoCommand::result RhinoGetSubCurve | ( | CArgsRhinoGetSubCurve & | args, |
ON_Curve ** | pC_Out | ||
) |
[in,out] | args | [in/out] |
[out] | pC_Out | [out] curve returned here |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetTcone | ( | CArgsRhinoGetTube & | args, |
ON_Brep & | Tcone | ||
) |
Description: UI tool to get a tcone. Parameters: args - [in] controls get point prompts, options, etc. tcone - [out] tcone returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetTcone | ( | CArgsRhinoGetTubeExtra & | args, |
ON_Brep & | Tcone | ||
) |
Description: UI tool to get a tcone. Parameters: args - [in] controls get point prompts, options, etc. tcone - [out] tcone returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_CLASS CRhinoCommand::result RhinoGetTorus | ( | CArgsRhinoGetTorus & | args, |
ON_Torus & | output_torus | ||
) |
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetTube | ( | CArgsRhinoGetTube & | args, |
ON_Brep & | Tube | ||
) |
Description: UI tool to get a tube. Parameters: args - [in] controls get point prompts, options, etc. tube - [out] tube returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetTube | ( | CArgsRhinoGetTube & | args, |
ON_Brep & | Tube, | ||
bool | bPromptForThickness, | ||
double & | WallThickness | ||
) |
Description: UI tool to get a tube. Parameters: args - [in] controls get point prompts, options, etc. tube - [out] tube returned here bPromptForThickness - [in] determines whether to prompt for WallThickness WallThickness - [in] initial value for WallThickness, used if bPromptForThickness is true Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION CRhinoCommand::result RhinoGetTube | ( | CArgsRhinoGetTubeExtra & | args, |
ON_Brep & | Tube | ||
) |
Description: New and improved UI tool to get a tube. Wraps Thickness stuff into the args class and also has a BothSides option. Parameters: args - [in] controls get point prompts, options, etc. tube - [out] tube returned here Returns: CRhinoCommand::success if successful.
RHINO_SDK_FUNCTION bool RhinoIs3dmBackupFileExtension | ( | const wchar_t * | sExtension | ) |
Parameters: sExtension - [in] file extension beginning with a "." Returns: True if sExtension is ".3dmbak" or ".3dm.bak".
RHINO_SDK_FUNCTION bool RhinoIs3dmBackupFileName | ( | const wchar_t * | sPath | ) |
Parameters: sPath - [in] name of file. Returns: True if the file name ends in ".3dmbak" or ".3dm.bak".
const RHINO_SDK_FUNCTION wchar_t* RhinoPathFindFileExtension | ( | const wchar_t * | sPath | ) |
Copyright (c) 1993-2017 Robert McNeel & Associates. All rights reserved. Rhinoceros is a registered trademark of Robert McNeel & Associates.
THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY. ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
For complete Rhino SDK copyright information see http://www.rhino3d.com/developer. Description: Find the extension of the filename passed in as sPath. This function is required to properly handle the name.ext.bak files Rhino 4 and early beta versions of Rhino 5 created. Parameters: sPath - [in] A null terminated string that contains the path to search. Returns If the sPath parameter is null, then a null is returned. If no extension is found, then a null is returned (this is different than Windows' PathFindExtension() which returns a pointer to the null terminator in sPath. If the sPath parameter is not a null and a valid extension exists, then the address of the "." that precedes the extension is returned. Remarks: The RhinoPathFindFileExtension() function works like the as Windows' PathFindExtension(), with three exceptions: 1) RhinoPathFindFileExtension() will return ".ext.bak" when sPath is "filename.ext.back" while Windows' PathFindExtension() will return ".bak". 2) RhinoPathFindFileExtension() returns null in all other cases. 3) RhinoPathFindFileExtension() dow not limit path names to MAX_PATH characters.
Note: Valid Windows extensions cannot contain spaces.
RHINO_SDK_FUNCTION ON_PlaneSurface* RhinoPlaneThroughBox | ( | const ON_Line & | line_in, |
const ON_3dVector & | vector_in, | ||
const ON_BoundingBox & | bbox | ||
) |
bounding box through which to cut
Description Make a plane that includes a line and a vector and goes through a bounding box Parameters: [in] line_in - line in the plane [in] vector_in - vector in the plane [in] bbox - box to cut through Returns: ON_PlaneSurface - a plane that goes thriugh the box NULL for error Remarks: Makes a plane from the line and vector and projects the corners of the box to it
line_in | line contained it returned plane |
vector_in | vector contained in returned plane |
RHINO_SDK_FUNCTION ON_PlaneSurface* RhinoPlaneThroughBox | ( | const ON_Plane & | plane_in, |
const ON_BoundingBox & | bbox | ||
) |
box through which to extend
Description Extend a plane so that it goes through a bounding box Parameters: [in] line_in - line in the plane [in] vector_in - vector in the plane [in] bbox - box to cut through Returns: ON_PlaneSurface - a plane that goes through the box NULL for error Remarks: Projects the corners of the box to the plane and sets the domain to include the projections
plane_in | plane to extend through box |
RHINO_SDK_FUNCTION ON_NurbsSurface* RhinoRailRevolve | ( | const ON_Curve * | provile_curve, |
const ON_Curve * | rail_curve, | ||
const ON_Line & | axis, | ||
bool | bScaleHeight, | ||
ON_NurbsSurface * | srf | ||
) |
Description: Create a rail revolve surface. Parameters: profile_curve - [in] rail_curve - [in] axis - [in] bScaleHeight - [in] srf - [in] Example:
CArgsRhinoRailRevolve args; CRhinoCommand::result cmdrc = RhinoGetRailRevolveInput(args); if ( CRhinoCommand::success == cmdrc ) { ON_NurbsSurface* srf = RhinoRailRevolve( args.ProfileCurve(), args.RailCurve(), args.Axis(), args.ScaleHeight() NULL ); }
Returns: If successful, a pointer to the surface is returned. If the input srf pointer was not NULL, then the returned point = srf. If the input srf point was NULL, then the returned surface was allocated with ON_NurbsCurve::New(). See Also: RhinoGetRailRevolveInput
RHINO_SDK_FUNCTION ON_Surface* RhinoRevolve | ( | ON_Curve * | pProfile, |
ON_Line & | axis, | ||
ON_Interval & | domain, | ||
bool | bDeformable = false , |
||
int | pointcount = 0 |
||
) |
Description: Non-interactive Rotated Surface maker Make 1 Revolved Surface from 1 profile, axis, and angle domain Parameters: pProfile [in] - The curve to revolve axis [in] - Revolve around this line domain [in] - starting and ending angles for the revolve Returns: Pointer to the Revolved surface or NULL on error